DECLARE SUB Morse (letter$)
CLS

INPUT "Filename: ", filename$

DO
    INPUT "Rate(40~255): ", rate%
LOOP UNTIL rate% > 39 AND rate% < 256

OPEN filename$ FOR INPUT AS #1
PRINT "Press any key to quit..."
PLAY "t" + LTRIM$(STR$(rate%))
PLAY "o3"
LOCATE , , 1, 0, 7

WHILE NOT EOF(1) AND INKEY$ = ""
    a$ = INPUT$(1, #1)
    IF a$ <> CHR$(10) THEN
        PRINT a$;
        Morse a$
    END IF
WEND

CLOSE #1
LOCATE , , , 7, 7
END

SUB Morse (letter$)
    CONST dot = "g30p30"
    CONST dash = "g5"
    CONST pause = "p10"

    SELECT CASE ASC(UCASE$(letter$))
    CASE 48
        PLAY dash + dash + dash + dash + dash
    CASE 49
        PLAY dot + dash + dash + dash + dash
    CASE 50
        PLAY dot + dot + dash + dash + dash
    CASE 51
        PLAY dot + dot + dot + dash + dash
    CASE 52
        PLAY dot + dot + dot + dot + dash
    CASE 53
        PLAY dot + dot + dot + dot + dot
    CASE 54
        PLAY dash + dot + dot + dot + dot
    CASE 55
        PLAY dash + dash + dot + dot + dot
    CASE 56
        PLAY dash + dash + dash + dot + dot
    CASE 57
        PLAY dash + dash + dash + dash + dot

    CASE 65
        PLAY dot + dash
    CASE 66
        PLAY dash + dot + dot + dot
    CASE 67
        PLAY dash + dot + dash + dot
    CASE 68
        PLAY dash + dot + dot
    CASE 69
        PLAY dot
    CASE 70
        PLAY dot + dot + dash + dot
    CASE 71
        PLAY dash + dash + dot

    CASE 72
        PLAY dot + dot + dot + dot
    CASE 73
        PLAY dot + dot
    CASE 74
        PLAY dot + dash + dash + dash
    CASE 75
        PLAY dash + dot + dash
    CASE 76
        PLAY dot + dash + dot + dot
    CASE 77
        PLAY dash + dash
    CASE 78
        PLAY dash + dot

    CASE 79
        PLAY dash + dash + dash
    CASE 80
        PLAY dot + dash + dash + dot
    CASE 81
        PLAY dash + dash + dot + dash
    CASE 82
        PLAY dot + dash + dot
    CASE 83
        PLAY dot + dot + dot
    CASE 84
        PLAY dash

    CASE 85
        PLAY dot + dot + dash
    CASE 86
        PLAY dot + dot + dot + dash
    CASE 87
        PLAY dot + dash + dash
    CASE 88
        PLAY dash + dot + dot + dash
    CASE 89
        PLAY dash + dot + dash + dash
    CASE 90
        PLAY dash + dash + dot + dot

    CASE ELSE
        PLAY pause
    END SELECT

    PLAY pause
END SUB

